<?php

if (file_exists("../../../wp-load.php")) {
  require_once("../../../wp-load.php");
}


function mongolatern_reIndexContent() {
  //  connect to mongodb
  $mongoConn = new Mongo(get_option('mongolantern_database_host').':'.get_option('mongolantern_database_port'));
  $MongoDB = $mongoConn->selectDb(get_option('mongolantern_database_database'));
  
  $indexer = new MongoLanternIndexer($MongoDB);
  
  //  Set Index name on MongoDB
  $indexer->indexName = get_option('mongolantern_index_name');
  
  $indexer->dictionaryEnabled(false);
  
  //  Connect to MongoInstance
  $indexer->Connect($MongoDB);
  
  //  Set fields to be searched later. On this field list the index will be optimized */
  $indexer->setFields(array(
    'title',
  ));
  
  $postsList = get_posts(array(
    'numberposts'     => 1000,
  ));
  foreach($postsList as $postInfo) {
    setup_postdata($postInfo);       
    
    //  prepare tag string
    $tagList = array();
    foreach(get_tags() as $tagInfo) {
      $tagList[] = $tagInfo->name;
    }
    
    //  prepare tag string
    $categoryList = array();
    foreach(get_categories() as $categoryInfo) {
      $categoryList[] = $categoryInfo->name;
    }
    
    //  TODO: Configuration to include/exclude author
    
    
    //  convert object to array
    $postInfo = (array) $postInfo;
    
    //  prepare blurb string for indexing
    $blurbString = $postInfo['post_title'] . ', ' . implode(' ', $tagList) . ', ' . implode(' ', $categoryList) . ', ' .strip_tags($postInfo['post_content']);    
    
    //  Create MongoLantern advanced document object
    $docObj = new MongoLanternDocument();
    $docObj->setField(MongoLanternField::Keyword('title', $postInfo['post_title']))
           ->setField(MongoLanternField::UnIndexed('guid', $postInfo['guid']))
           ->setField(MongoLanternField::UnStored('blurb', $blurbString));
           
    
    //  $index must have to be unique and constant for any document, it wil require to update the document later.
    $indexer->setDocument($postInfo['ID'], $docObj);
    unset($docObj);
    
    $indexer->Commit();
  }
  
  //  print "Optimizing Index...\n";
  $indexer->Optimize();
}

if(!empty($_SERVER['HTTP_REFERER'])) {  
  mongolatern_reIndexContent();
}



