<?php

/* register settings */
function mongolantern_settings_init(){
  register_setting('mongolantern_settings', 'mongolantern_database_host', 'mongolantern_settings_validate');
  register_setting('mongolantern_settings', 'mongolantern_database_port', 'intval');
  register_setting('mongolantern_settings', 'mongolantern_database_database', 'mongolantern_settings_validate');
  register_setting('mongolantern_settings', 'mongolantern_index_name', 'mongolantern_settings_validate');
  register_setting('mongolantern_settings', 'mongolantern_index_schedule', 'intval');
}

function mongolantern_settings_validate($input) {  
  return $input;
}

function showSettingsForm() {
?>
<style type="text/css">
#mongoLanternSettings {
  width: 600px;
  margin: 10px auto;
  min-height: 300px;
  border: 1px solid #DADADA;
  font-family: Helvetica, Arial;
  padding: 10px;
}
#mongoLanternSettings h1.heading  {
  font-size: 1.2em;  
}
#mongoLanternSettings h1.heading  img {
  vertical-align: top;
}
#mongoLanternSettings tr  b {
  font-size: 14px;
}
#mongoLanternSettings tr  label {
  font-size: 13px;
}
</style>

<script type="text/javascript">
function reindexContent() {
  var response = confirm('Are you sure reindex contents? It may take long. Don\'t refresh the page or close the browser tab.');
  if(true === response) {
    jQuery.ajax({
      url: '<?php echo MONGOLANTERN_URL  ?>reindex.php',
      cache: false,
      async: false,
      beforeSend: function() {
        //  alert('The page may take long to load. Don\'t refresh the page or close tha browser tab.');
      },
      success: function() {
        alert('Congratulations!!! Reindex Successful. You can now have latest post into search results.');
      }
    });
  }
}
</script>
  <div id="mongoLanternSettings">
    <h1 class="heading"><img src="<?php echo MONGOLANTERN_URL.'resources/images/' ?>settings.png" /> MongoLantern Settings</h2>
    <form method="post" action="options.php">
      <?php settings_fields('mongolantern_settings'); ?>
      
      <table class="form-table">
        <!-- Title rewriting -->
        <tbody>
          <tr>
            <th colspan="2"><b>&raquo; Database Settings:</b></th>
          </tr>
          <tr>
            <th style="text-align:right; vertical-align:top;" scope="row">
              <label for="mongolantern_database_host">Database Server Host: </label>
            </th>
            <td>
              <input id="mongolantern_database_host" name="mongolantern_database_host" type="textbox" placeholder="localhost" value="<?php echo get_option('mongolantern_database_host'); ?>" /> <br />
            </td>
          </tr>
          
          <tr>
            <th style="text-align:right; vertical-align:top;" scope="row">
              <label for="mongolantern_database_port">Database Server Port: </label>
            </th>
            <td>
              <input id="mongolantern_database_port" name="mongolantern_database_port" type="textbox" placeholder="27017" value="<?php echo get_option('mongolantern_database_port'); ?>" /> <br />
            </td>
          </tr>
          
          <tr>
            <th style="text-align:right; vertical-align:top;" scope="row">
              <label for="mongolantern_database_port">Database Name: </label>
            </th>
            <td>
              <input id="mongolantern_database_database" name="mongolantern_database_database" type="textbox" placeholder="wp_mongolantern" value="<?php echo get_option('mongolantern_database_database'); ?>" /> <br />
            </td>
          </tr>
                    
          <tr>
            <th colspan="2"><b>&raquo; Index Settings:</b></th>
          </tr>
          <tr>
            <th style="text-align:right; vertical-align:top;" scope="row">
              <label for="mongolantern_index_name">Index Name: </label>
            </th>
            <td>
              <input id="mongolantern_index_name" name="mongolantern_index_name" type="textbox" placeholder="" value="<?php echo get_option('mongolantern_index_name'); ?>" /> <br />
            </td>
          </tr>
          <tr>
            <th style="text-align:right; vertical-align:top;" scope="row">
              <label for="mongolantern_index_schedule">Index Every: </label>
            </th>
            <td>
              <input id="mongolantern_index_schedule" name="mongolantern_index_schedule" type="textbox" placeholder="1" value="<?php echo get_option('mongolantern_index_schedule'); ?>" /> hrs<br />
            </td>
          </tr>          
          
        </tbody>
      </table>
      
      <p>
        <input type="submit" value="Save Changes" class="button button-primary" id="submit" name="submit"> &nbsp;&nbsp;&nbsp;&nbsp;
        <input type="button" value="Reindex Now" class="button button-primary" id="reindex" name="reindex" onclick="reindexContent();">
      </p>
    </form>
  </div>
<?php } ?>


